/* сжимаем код через clean-css */
'use strict';

var assert = require('assert');
var tryCatch = require('try-catch');
var Clean = require('clean-css');

var ErrorMsg = Error(['can\'t load clean-css', 'npm install clean-css', 'https://github.com/GoalSmashers/clean-css'].join('\n'));

/**
 * minify css data.
 *
 * @param data
 * @param callback
 */
module.exports = function (data, callback) {
    assert(data);
    assert(callback);

    if (!Clean) return callback(ErrorMsg);

    var dataOptimized = void 0;
    var errorParse = void 0;

    var error = tryCatch(function () {
        var min = new Clean().minify(data);

        dataOptimized = min.styles;
        errorParse = min.errors[0];
    });

    callback(errorParse || error, dataOptimized);
};