'use strict';

var promisify = require('es6-promisify').promisify;
var currify = require('currify/legacy');

module.exports = function (fn, ctx) {
    check(fn);
    checkCount(fn.length);
    
    var f = fn.bind(ctx);
    
    var funcs = [
        function (a) { return promisify(f, ctx)(a); },
        function (a, b) { return promisify(f, ctx)(a, b); },
        function (a, b, c) { return promisify(f, ctx)(a, b, c); } ];
    
    var count = f.length - 2;
    return currify(funcs[count]);
};

function check(fn) {
    if (typeof fn !== 'function')
        { throw Error('fn should be a function!'); }
}

function checkCount(count) {
    if (count > 4)
        { throw Error('fn takes to much arguments, up to 4 supported'); }
}

